<?php

namespace App\Controllers\Api;

use LMVC\System\Request;
use LMVC\System\Response;

class CallHome extends \LMVC\System\Controller
{
    protected $settingsModel;

    public function __construct()
    {
        parent::__construct();
        $serverPort= getCgiPort();  
        
        $flagPermission = false;

        $this->settingsModel = $this->model('SettingsModel');
        $this->fileLogModel = $this->model('FileLogModel');
        $this->qtsModel = $this->model('QTSModel');
        $this->LogModel = $this->model('LogModel');
        $this->qcloudModel = $this->model('QCloudModel');
        $this->qtsModel->qtsApiPort = $serverPort;

        if(!$this->qtsModel->isCSRFVerify()){
            $this->fileLogModel->logError('CSRF error', __FILE__);
            Response::error(403, apiFormater("Fail", 2020));
        }

        if (!$this->qtsModel->isValidUser()) {
            $this->fileLogModel->logError('You do not have permission to use this API.', __FILE__);
            Response::error(403, apiFormater("Fail", 2000));
        }
    }
    public function getCallHomeService(){
        $result = $this->settingsModel->getCallHomeService();
        return array('callHomeService' => $result );
    }
    public function getCallHomeTime(){
        $result = $this->settingsModel->getCallHomeTime();
        return array('callHomeTime' => $result );
    }
    public function getCallHomeLog(){
        $result = $this->settingsModel->getCallHomeLog();
        return array('callHomeLog' => $result );
    }
    public function getCallHome($type = null)
    {

        $arrSettings = array_merge(
            $this->getCallHomeService(),
            $this->getCallHomeTime(),
            $this->getCallHomeLog()
        );
        Response::json($arrSettings);
    }

    public function setCallHome(){
        /*
        $isOn=Request::any('isOn');
        $time=Request::any('time');
        $timeVaild=preg_match("/^(?:2[0-3]|[01][0-9]):[0-5][0-9]$/", $time);
        if($timeVaild){
            $this->settingsModel->setCallHomeService($isOn);
            $this->settingsModel->setCallHomeTime($time);
            chmod('/mnt/ext/opt/qdesk/shell/enableCallHome.sh', 0755);
            chmod('/mnt/ext/opt/qdesk/shell/disableCallHome.sh', 0755);
            if($isOn){
                shell_exec('/mnt/ext/opt/qdesk/shell/enableCallHome.sh');
                $this->fileLogModel->logDebug('Call Home enable.', __FILE__, __LINE__);
            }else{
                shell_exec('/mnt/ext/opt/qdesk/shell/disableCallHome.sh'); 
                $this->settingsModel->setCallHomeLog(true);
                $this->fileLogModel->logDebug('Call Home disable.', __FILE__, __LINE__);
            }
            $arrSettings = array_merge(
                $this->getCallHomeService(),
                $this->getCallHomeTime(),
                $this->getCallHomeLog()
            );
            Response::json($arrSettings);
        */
        }else{
            Response::error(403, apiFormater(null, 3006));
        }
    }

}
