<?php

namespace App\Controllers\Api;

use LMVC\System\Request;
use LMVC\System\Response;

class DiagnosticTool extends \LMVC\System\Controller
{
    protected $diagnosticToolModel;
    protected $customPortalModel;

    public function __construct()
    {
        parent::__construct();
        $serverPort= getCgiPort();
        

        $this->customPortalModel = $this->model('CustomPortalModel');
        $this->diagnosticToolModel = $this->model('DiagnosticToolModel');
        $this->fileLogModel = $this->model('FileLogModel');
        $this->qtsModel = $this->model('QTSModel');
        $this->qtsModel->qtsApiPort = $serverPort;
        $this->customPortalModel->qtsApiPort = $serverPort;

        if(!$this->qtsModel->isCSRFVerify()){
            $this->fileLogModel->logError('CSRF error', __FILE__);
            Response::error(403, apiFormater("Fail", 2020));
        }

        if (!$this->qtsModel->isValidUser()) {
            $this->fileLogModel->logError('You do not have permission to use this API.', __FILE__);
            Response::error(403, apiFormater("Fail", 2000));
        }
       
    }

    public function getSettings($type = null)
    {
        switch ($type) {
            case 'showDiagWarning':
                Response::json(apiFormater($this->diagnosticToolModel->getShowDiagWarning()));
                break;
            default:
                $arrSettings = [];
                Response::json($arrSettings);
                break;
        }
    }

    public function setSettings($type = null)
    {
        $isShowDiagWarning = Request::any('isShowDiagWarning');

        switch ($type) {
            case 'showDiagWarning':
                Response::json(apiFormater($this->diagnosticToolModel->setShowDiagWarning($isShowDiagWarning)));
                break;
            default:
                $arrSettings = [];
                Response::json($arrSettings);
                break;
        }
    }

    public function getDumpLogTime(){
        $time=$this->diagnosticToolModel->getDumpLogTime();
        Response::json(['endtime'=>$time]);
    }

}
