<?php

namespace App\Controllers\Cli;

class CallHome extends \LMVC\System\Controller
{
    protected $remoteAccessModel;
    protected $logModel;
    protected $tmpKeyPath;
    protected $forwardSrvPort = 22;

    public function __construct()
    {
        parent::__construct();

        $this->remoteAccessModel = $this->model('RemoteAccessModel');
        $this->qtsModel = $this->model('QTSModel');
        $this->logModel = $this->model('LogModel');
        $this->settingsModel = $this->model('SettingsModel');
        $this->fileLogModel = $this->model('FileLogModel');
        $this->remoteAccessModel->fileLogModel = $this->fileLogModel;

        $this->logPath = config('app_dir') . '/../callhome/';
        $this->cfgPath = '/etc/callhome.conf';

        $this->logLinkPath = "/var/log/callhome/";
        $this->logEmergency = $this->logLinkPath."emergency/";
        $this->logRegular= $this->logLinkPath."regular/";
        $this->qcloudModel = $this->model('QCloudModel');
        $this->qcloudModel->fileLogModel = $this->fileLogModel;
        $this->apiGWUrl = 'https://' . config('api_gateway_server') . '/callhome';

        // if (strtolower(php_sapi_name()) !== 'cli') {
        // $this->fileLogModel->logError('You can not use this function via web.', __FILE__);
        // die('You can not use this function via web. File: ' . __FILE__);
        // }
    }
    public function liveOrDie()
    {
        chmod(config('app_dir') . '/../shell/enableCallHome.sh', 0755);
        chmod(config('app_dir') . '/../shell/disableCallHome.sh', 0755);
        $status = $this->settingsModel->getCallHomeService();
        if($status) {
            $this->fileLogModel->logDebug('CallHome woof');
            shell_exec('/mnt/ext/opt/qdesk/shell/enableCallHome.sh');
            return 'Enable CallHome';
        } else {
             //status is disabled
            $this->fileLogModel->logDebug('Exit CallHome');
            shell_exec('/mnt/ext/opt/qdesk/shell/disableCallHome.sh');

            return 'Disable CallHome';
           
        }
    }

    public function enable()
    {
        if(!file_exists($this->cfgPath)){
            shell_exec('touch '.$this->cfgPath);
        }
        $this->updateCfgTime();

        if(!file_exists($this->logPath)){
            mkdir($this->logPath);
        }
        if(!file_exists($this->logLinkPath)){
            shell_exec('ln -sf '.$this->logPath.' /var/log/');
        } 
        if(!file_exists($this->logRegular)){
             mkdir($this->logRegular);
        }
        if(!file_exists($this->logEmergency)){
             mkdir($this->logEmergency);
        }

    }
    public function disable()
    {
        if(file_exists($this->logPath)){
            shell_exec('rm -rf '.$this->logPath);
        }
        if(is_link($this->logLinkPath)){
            unlink($this->logLinkPath);
        }
        if(file_exists($this->cfgPath)){
            unlink($this->cfgPath);
        }

    }
    public function updateCfgTime(){
        $time = $this->settingsModel->getCallHomeTime();
        $hh= explode(':', $time)[0];
        $mm= explode(':', $time)[1];
        $mtime=date("Ymd").$hh.$mm.".00";
        $fmtime=date("H:i",filemtime($this->cfgPath));
        if($fmtime!=$time){
            echo 'touch -m -t '.$mtime.' '.$this->cfgPath;
            shell_exec('touch -m -t '.$mtime.' '.$this->cfgPath); 
        }
    }
    public function regularTime(){
        $time = $this->settingsModel->getCallHomeTime();
        $hh= explode(':', $time)[0];
        $mm= explode(':', $time)[1];
        echo intval($mm).' '.intval($hh);
    }
    public function regular(){
        if(!file_exists($this->logPath)){
            mkdir($this->logPath);
        }
        if(!file_exists($this->logLinkPath)){
            shell_exec('ln -sf '.$this->logPath.' /var/log/');
        }
        if(!file_exists($this->logRegular)){
             mkdir($this->logRegular);
        }
        $logs = preg_grep('/^([^.])/',scandir($this->logRegular));
        foreach($logs as $key => $f){
            $this->uploadQcloud($this->logRegular.$f);
        }
        $this->fileLogModel->logDebug("upload woof");
    }
    public function woof()
    {
        $this->qcloudModel->refreshToken('qidBind');
        if(!file_exists($this->cfgPath)){
            shell_exec('touch '.$this->cfgPath);
        }
        $this->updateCfgTime();

        if(!file_exists($this->logPath)){
            mkdir($this->logPath);
        }
        if(!file_exists($this->logLinkPath)){
            shell_exec('ln -sf '.$this->logPath.' /var/log/');
        }
        if(!file_exists($this->logEmergency)){
             mkdir($this->logEmergency);
        }
        if(!file_exists($this->logRegular)){
             mkdir($this->logRegular);
        }
        $logs = preg_grep('/^([^.])/',scandir($this->logEmergency));
        foreach($logs as $key => $f){
            $this->uploadQcloud($this->logEmergency.$f);
        }
        $this->fileLogModel->logDebug("upload woof");

    }

    function uploadQcloud($file){

        try {
            $fileData=json_decode(file_get_contents($file));
        } catch (Exception $e) {
            $fileData=false;
        }
        if(!$fileData){
            $this->fileLogModel->logDebug("callhome format Error: ${file}", __FILE__, __LINE__);
            return;
        }

        chmod(config('app_dir') . '/data/script/qts_type', 0755);
        $cmd = config('app_dir') . '/data/script/qts_type';
        $name = trim(shell_exec($cmd));
        $firmware=trim(shell_exec('/sbin/getcfg system version ')).'_'.trim(shell_exec('/sbin/getcfg system "Build Number"'));
        if($name=="QuTScloud")$firmware="c".$firmware;
        if($name=="QuTShero")$firmware="h".$firmware;
        $hwsn=trim(shell_exec('get_hwsn'));
        $model=str_replace("\n", '', shell_exec("/sbin/getcfg -f /etc/model.conf 'System Enclosure' MODEL"));
        $nodeWise =[];
        $nodeWise['product_name']=$name;
        $nodeWise['product_serial']=$hwsn;
        $nodeWise['product_model']= $model;
        $nodeWise['fw_version']=$firmware;

        $nodeWise['qid']=$this->qcloudModel->getBindQid();
        $nodeWise['user_id']=$this->qcloudModel->getBindUserId();
        foreach ($fileData as $key => $value) {
            if(is_string($value)){
                $nodeWise[$key]=$value;
            }
        }
        foreach ($nodeWise as $key => $value) {
                $fileData->$key=$value;
        }
        file_put_contents($file,json_encode($fileData,JSON_PRETTY_PRINT));

        $curlUrl = $this->apiGWUrl . '/log/upload';
        $curlPostFields = $nodeWise;
        $info = pathinfo($file);
        $curlPostFields['hardware_serial_number'] = $hwsn;
        $curlPostFields['model'] = $model;
        $curlPostFields['log_file'] = curl_file_create($file,mime_content_type($file),$info['filename']);
        $token = $this->qcloudModel->getCachedToken('qidBind');
        if(!$token['access_token']){
            return array('status' => 3000, 'result' => null);
        }
        $header =array(
            'X-Qid-Authorization: '.$token['access_token'],
        );

        $srvOutput = curlWrapper('POST', $curlUrl, $curlPostFields, false, $header);
        if (is_array($srvOutput)) {
            $srvOutput = json_encode($srvOutput);
            $srvOutput = json_decode($srvOutput);
        }else{
            $srvOutput = json_decode($srvOutput);
        }
        if(isset($srvOutput->httpStatusCode)&&$srvOutput->httpStatusCode==200) {
            $this->fileLogModel->logDebug("callhome upload: ${file}", __FILE__, __LINE__);
            unlink($file);
        }else{
            $this->fileLogModel->logDebug("callhome upload error: ${file}, message:".json_decode($srvOutput), __FILE__, __LINE__);
        }
    }
}
