<?php

namespace App\Models;

class LogModel extends \LMVC\System\Model
{
    public function __construct()
    {
        parent::__construct();
    }

    public function qtsLog()
    {
        $numArgs = func_num_args();
        if ($numArgs>0) {
            $args = func_get_args();
            $msgId=$args[0];
            $msg=$this->getMsgNC($msgId);
            if(is_array($msg)){
                $cmd="qne-nc send -L/usr/share/qne/locale -t3 -Aqne-helpdesk -C".$msg[1]."  -M".$msgId." -l".$msg[0]." '".$msg[2]."' '%qne-helpdesk:qne-helpdesk:Helpdesk%'"; 
                if($numArgs>1){
                    foreach($args as $index => $arg) {
                        if($index>0){
                            //$cmd=$cmd.' '.escapeshellarg($arg);
                            $tmp=urldecode($arg);
                            $cmd=$cmd.' '.escapeshellarg($tmp);
                        }
                    }
                }
                $set_charset = 'export LANG=en_US.UTF-8;';       
                exec($set_charset.$cmd, $output, $result); 
                /*if($result > 0) 
                { 
                    $msg=$this->getMsg($msgId);
                    if($numArgs>1){
                        foreach($args as $index => $arg) {
                            if($index>0){
                                $msg[1]= str_replace("{".$index."}",escapeshellarg($arg),$msg[1]);
                            }
                        }
                    }
                    if($msg[0]=='info')
                        $this->qtsLogInfo($msg[1]);
                    else if($msg[0]=='error')
                        $this->qtsLogError($msg[1]);
                }
                */
                return $cmd;
            }
        }
    }

    private function getMsgNC($msgId){
        switch($msgId){
            case 1:
                return array('4','C001','[{0}] Failed to submit ticket due to poor internet connection.');
            
            case 2:
                return array('1','C001','[{0}] Submitted ticket: "{1}". Subject: "{2}".');

            case 3:
                return array('1','C002','[{0}] Remote support session is in progress. Do not change the NAS settings during this period.');

            case 4:
                return array('1','C002','[{0}] Remote support session has ended. Check if the issue has been resolved.');

            case 5:
                return array('1','C002','[{0}] Started the remote support session: "{1}". Duration: "{2}" to "{3}". Do not change the NAS settings during this period.');
            case 6:
                return array('1','C002','[{0}] Extended the remote support session to "{1}".');

            case 7:
                return array('4','C002','[{0}] Failed to start the remote support session. Invalid Ticket ID.');

            case 8:
                return array('4','C002','[{0}] Failed to start the remote support session due to poor internet connection.');
        }
        return false;
    }
    private function getMsg($msgId){
        switch($msgId){
            case 1:
                return array('error','Submit ticket failed due to limited internet connection.');
            
            case 2:
                return array('info','Your ticket #{1} has been submitted. Subject: {2}');

            case 3:
                return array('info','Your remote support session is starting, please do not change the NAS settings during this period.');

            case 4:
                return array('info','Your remote support session was finished, please check for result.');

            case 5:
                return array('info','You have enable remote support with #{1} from {2} to {3}.');
            case 6:
                return array('info','Your remote support session is been extended to {1}.');

            case 7:
                return array('error','Enable remote support fail due to Ticket ID not valid.');

            case 8:
                return array('error','Enable remote support fail due to limited internet connection.');
        }
        return false;
    }

    public function qtsLogInfo($msg)
    {
        if (!empty($msg)) {
            $now = date('Y-m-d');
            shell_exec("/sbin/log_tool -t0 -uSystem -p127.0.0.1 -mlocalhost -a ".escapeshellarg("[Helpdesk] {$msg}"));
            shell_exec("/sbin/notice_log_tool -t6 -uSystem -p127.0.0.1 -mlocalhost -a ".escapeshellarg("[Helpdesk] {$msg}"));
        }
    }

    public function qtsLogWarn($msg)
    {
        if (!empty($msg)) {
            $now = date('Y-m-d');
            shell_exec("/sbin/log_tool -t1 -uSystem -p127.0.0.1 -mlocalhost -a '[Helpdesk] {$msg}'");
        }
    }

    public function qtsLogError($msg)
    {
        if (!empty($msg)) {
            $now = date('Y-m-d');
            shell_exec("/sbin/log_tool -t2 -uSystem -p127.0.0.1 -mlocalhost -a ".escapeshellarg("[Helpdesk] {$msg}"));
        }
    }

    public function setAppLog($msgId = '', $arrMsgMeta = array())
    {
        $arrMsgIdList = array(
            'notification_submitTicket_success',
            'notification_submitTicket_failed',
            'notification_waitForActivate',
            'notification_remoteSupport_failed_unableToConnect',
            'notification_remoteSupport_failed_invaildTicket',
            'notification_remoteSupport_success',
            'notification_remoteSupport_inProgress',
            'notification_remoteSupport_finished',
            'notification_qid_login',
            'notification_qid_logout',
            'notification_setting_apply',
            'notification_setting_keep'
        );

        if (empty($msgId)) {
            return false;
        }

        $now = time();
        $msgMeta = json_encode($arrMsgMeta);
        $rowCount = 0;

        $rowCount += $this->db->queryNoneResult("INSERT INTO log (msgId, msgMeta, createdTime) VALUES (?, ?, ?)",[$msgId, $msgMeta, $now]);

        if (in_array($msgId, $arrMsgIdList)) {
            $rowCount += $this->db->queryNoneResult("UPDATE configuration SET cfgValue = '{$msgId}' WHERE cfgKey = 'lastSetLogMsgId'");
        }

        if ($rowCount <= 0) {
            return false;
        }

        return true;
    }

    public function getAppLog($logKeepDays = '')
    {
        $rsLogs = null;

        if (!empty($logKeepDays)) {
            $now = time();
            $showUntil = strtotime("-$logKeepDays days", $now);
            $rowCount = $this->db->queryNoneResult("DELETE FROM log WHERE createdTime < {$showUntil}");
            $rsLogs = $this->db->query("SELECT * FROM log WHERE createdTime >= {$showUntil} ORDER BY createdTime DESC");
        } else {
            $rsLogs = $this->db->query("SELECT * FROM log ORDER BY createdTime DESC");
        }

        return $rsLogs;
    }

    public function isLogSet($msgId)
    {
        $isSet = $this->db->queryDataIsExist("SELECT cfgValue FROM configuration WHERE cfgKey = 'lastSetLogMsgId' AND cfgValue = '{$msgId}'");

        return $isSet;
    }

    public function isRemoteLogSet($msgId)
    {
        $isSet = $this->db->queryDataIsExist("SELECT cfgValue FROM configuration WHERE cfgKey = 'lastRemoteLogMsgId' AND cfgValue = '{$msgId}'");

        return $isSet;
    }

    public function setRemoteLog($msgId)
    {
        $rowCount = 0;
        $isSet = $this->db->queryDataIsExist("SELECT cfgKey FROM configuration WHERE cfgKey = 'lastRemoteLogMsgId'");

        if($isSet)
            $rowCount += $this->db->queryNoneResult("UPDATE configuration SET cfgValue = '{$msgId}' WHERE cfgKey = 'lastRemoteLogMsgId'");
        else 
            $rowCount += $this->db->queryNoneResult("INSERT INTO configuration (cfgKey, cfgValue) VALUES ('lastRemoteLogMsgId', '{$msgId}')");

        if ($rowCount <= 0) return false;
        
        return true;
    }
}
