<?php

namespace App\Models;
use LMVC\System\Request;
use RecursiveIteratorIterator;
use RecursiveDirectoryIterator;

libxml_use_internal_errors(true);

class QTSModel extends \LMVC\System\Model
{
    public function __construct()
    {
        parent::__construct();
    }
    function getallheaders() 
    { 
       $headers = array (); 
       foreach ($_SERVER as $name => $value) 
       { 
           if (substr($name, 0, 5) == 'HTTP_') 
           { 
               $headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value; 
           } 
       } 
       if(strpos($_SERVER['REQUEST_URI'],'log/download')!==false){
        if(Request::any('at'))$headers['X-Access-Token']=Request::any('at');
        if(Request::any('csrf'))$headers['X-Csrf-Token']=Request::any('csrf');
       }
       return $headers; 
    } 
    public function getCSRFtoken()
    {
        if(empty($_SESSION['token'])||empty($_SESSION['token_expired'])){
            $_SESSION['token']=base64_encode(openssl_random_pseudo_bytes(32));
            $_SESSION['token_expired']=time()+ini_get("session.gc_maxlifetime");
        }
        return $_SESSION['token'];
    }
    public function isCSRFVerify($token=null){
        if(isset($_SERVER['REQUEST_METHOD']) && strtoupper($_SERVER['REQUEST_METHOD'])=='POST'){
            $headers=$this->getallheaders();
            if(!isset($headers['X-Csrf-Token']) || trim($headers['X-Csrf-Token']) != $this->getCSRFtoken()){
                return false;
            }
        }
        return true;
    }
   
    public function isValidUser(){
        $headers=$this->getallheaders();
        if(!isset($headers['X-Access-Token'])){
            return false;
        }
        $curlUrl = httpsOrNot() . "://localhost:{$this->qtsApiPort}/qne/oauth/tokeninfo?access_token={$headers['X-Access-Token']}";

        $srvOutput = curlWrapper('GET', $curlUrl);
        if (!is_array($srvOutput)) {
           $result= json_decode($srvOutput);
           if($result->create_time){
            return true;
           }
        }

        return false;
    }


    public function fixSSHDConfigPerm()
    {
         
        $sshdCfgPath = "/etc/ssh/";
        if(!file_exists($sshdCfgPath)){
            return false;
        }

        // Fix folder permission
        //chmod($sshdCfgPath, 0755);
        exec("qsh helpdeskd.fixMod -v '{\"path\":\"".$sshdCfgPath."\",\"type\":\"755\"}'");

        // Fix key permission
        $iterator = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($sshdCfgPath), RecursiveIteratorIterator::SELF_FIRST);

        $arrHostKey = array('ssh_host_dsa_key', 'ssh_host_rsa_key');
        $HostKey_chmod_600_file = "";
        foreach ($iterator as $file) {
    	if(!preg_match_all("/\.+$/im", $file, $match)){
                   if (in_array($file->getFileName(), $arrHostKey)) { 
    			       $HostKey_chmod_600_file = $HostKey_chmod_600_file . " " . $file; // Bug 101288 fix 
    				 } else {
    		        	//chmod($file, 0644);
                        if(strrpos($file, 'ssh_host_')===false||strrpos($file, '.pub')!==false){
                            exec("qsh helpdeskd.fixMod -v '{\"path\":\"".$file."\",\"type\":\"644\"}'");
                            //exec('chmod 0644 '.$file);
                        }else{
                            exec("qsh helpdeskd.fixMod -v '{\"path\":\"".$file."\",\"type\":\"600\"}'");
                            //exec('chmod 0600 '.$file);
                        }
    		        }
                }
    	}
    	shell_exec("chmod 0600 ".$HostKey_chmod_600_file); // Bug 101288 fix 
        return true;
    }
    function sshState(){
        $srvOutput=shell_exec('qsh service."GET /service/ssh" \'{"__HEADER__":{"QUERY_STRING":"subfunc=tel_ssh"}}\'');
        if (!is_array($srvOutput)) {
            $xml = new \SimpleXMLElement($srvOutput, LIBXML_NOERROR | LIBXML_NOCDATA);
            $result = array();
            if(isset($xml->func->ownContent->sshEnabled)){
                $value = (array)$xml->func->ownContent->sshEnabled;
                $result['sshEnabled'] = $value[0];
            } 

            return $result;

        }
        return false;
    }

    function sshEnable(){
        exec("qsh helpdeskd.enableSSH");
        $srvOutput=shell_exec('qsh service."POST /service/ssh" \'{"__HEADER__":{"QUERY_STRING":"subfunc=tel_ssh&apply=1&chk_ssh=1"}}\'');
        if (!is_array($srvOutput)) {
            $xml = new \SimpleXMLElement($srvOutput, LIBXML_NOERROR | LIBXML_NOCDATA);
            return $xml;
        }
        return false;
    }
    function sshDisable(){
        exec("qsh helpdeskd.disableSSH");
        $srvOutput=shell_exec('qsh service."POST /service/ssh" \'{"__HEADER__":{"QUERY_STRING":"subfunc=tel_ssh&apply=1"}}\'');
        if (!is_array($srvOutput)) {
            $xml = new \SimpleXMLElement($srvOutput, LIBXML_NOERROR | LIBXML_NOCDATA);
            return $xml;
        }
        return false;
    }

}
