<?php

namespace App\Models;

class SettingsModel extends \LMVC\System\Model
{
    public function __construct()
    {
        parent::__construct();
    }
    public function escape($v){
        return str_replace('\'', '\'\'', $v);
    }

    public function getShowGuides()
    {
        $isShowGuides = $this->db->querySingleRow("SELECT cfgValue FROM configuration WHERE cfgKey='showGuides'");

        return $isShowGuides['cfgValue'];
    }

    public function setShowGuides($needShowGuides = 1)
    {
        $needShowGuides=$this->escape($needShowGuides);
        return $this->db->query("UPDATE configuration SET cfgValue='{$needShowGuides}' WHERE cfgKey='showGuides'");
    }

    public function getMsgRetainDays()
    {
        $keepDays = $this->db->querySingleRow("SELECT cfgValue FROM configuration WHERE cfgKey='msgRetainDays'");

        return $keepDays['cfgValue'];
    }

    public function setMsgRetainDays($keepDays)
    {
        $keepDays=$this->escape($keepDays);
        $this->db->queryNoneResult("UPDATE configuration SET cfgValue='{$keepDays}' WHERE cfgKey='msgRetainDays'");
    }

    public function getAttachSyslog()
    {
        $needAttach = $this->db->querySingleRow("SELECT cfgValue FROM configuration WHERE cfgKey='attachSyslog'");

        return $needAttach['cfgValue'];
    }

    public function setAttachSyslog($needAttach)
    {
        $needAttach=$this->escape($needAttach);
        $this->db->queryNoneResult("UPDATE configuration SET cfgValue='{$needAttach}' WHERE cfgKey='attachSyslog'");
    }

    public function getUpdateWarn()
    {
        $updateWarn = $this->db->querySingleRow("SELECT cfgValue FROM configuration WHERE cfgKey='updateWarn'");

        if($updateWarn['cfgValue']==null){
            $this->db->querySingleRow("INSERT INTO 'configuration' VALUES ('updateWarn', 0)");
            return 0;
        }else{
            return $updateWarn['cfgValue'];
        }
    }

    public function setUpdateWarn($updateWarn)
    {
        $updateWarn=$this->escape($updateWarn);
        $this->db->queryNoneResult("UPDATE configuration SET cfgValue='{$updateWarn}' WHERE cfgKey='updateWarn'");
    }
        public function setNeedDisableSSH($status)
    {
        $this->db->queryNoneResult("INSERT OR REPLACE INTO configuration ('cfgKey','cfgValue') VALUES ('needDisableSSH', {$status})");
    }
    public function getNeedDisableSSH()
    {
        $needDisableSSH = $this->db->querySingleRow("SELECT cfgValue FROM configuration WHERE cfgKey='needDisableSSH'");
        if(!isset($needDisableSSH['cfgValue'])){
            $this->db->querySingleRow("INSERT INTO 'configuration' VALUES ('needDisableSSH', 0)");
            return "0";
        }else{
            return $needDisableSSH['cfgValue'];
        }
    }

}
