<?php

namespace App\Models;

class SupportUtilsModel extends \LMVC\System\Model
{

    public $uploadFile;

    public function __construct()
    {
        parent::__construct();
        $this->apiGWUrl = "https://".config('api_gateway_server') . '/help';
        $this->cpUrl = 'https://'.config('customPortal_server');
    }

    public function uploadFile()
    {
        $curlUrl =  $this->cpUrl . '/api/v2/casefile/upload';

        if (function_exists('curl_file_create')) {
            $this->uploadFile = curl_file_create($this->filePath);
        } else {
            $this->uploadFile = '@' . $this->filePath;
        }

        $curlPostFields = array(
            'caseId' => $this->ticketId,
            'replyRecordId' => null,
            'mode' => 'qdesk',
            //'source_path' => $this->filePath,
            'file' => $this->uploadFile);
        $token = $this->qcloudModel->getCachedToken();
        if(!$token['access_token']){
            return (object)array('status' => 3000, 'result' => null);
        }
        $header =array(
            'X-Qid-Authorization: '.$token['access_token'],
        );
        $srvOutput = curlWrapper('POST', $curlUrl, $curlPostFields,false,$header);

        if (is_array($srvOutput)) {
            $srvOutput = json_encode($srvOutput);
        }

        return json_decode($srvOutput);
    }

    public function getExternalLog()
    {
        $queryStr = "SELECT * FROM external_log";
        $rcExternalLogs = null;

        try {
            $rcExternalLogs = $this->db->query($queryStr);
        } catch (\Exception $e) {
            return false;
        }

        return $rcExternalLogs;
    }

    public function setExternalLog($appName, $appLogPath)
    {
        $now = time();
        $queryStr = "INSERT INTO external_log (appName, appLogPath, createdTime) VALUES ('$appName', '$appLogPath', '$now')";
        $rowCount = 0;

        try {
            $rowCount = $this->db->queryNoneResult($queryStr);
        } catch (\Exception $e) {
            return false;
        }

        return $rowCount;
    }

    public function removeExternalLog($appName)
    {
        $queryStr = "DELETE FROM external_log WHERE appName = '$appName'";
        $rowCount = 0;

        try {
            $rowCount = $this->db->queryNoneResult($queryStr);
        } catch (\Exception $e) {
            return false;
        }

        return $rowCount;
    }
}
