<?php
namespace LMVC\System\Db;

use \LMVC\System\App;
//use \PDO;
use SQLite3;

class SqliteDatabase implements IDatabase
{
	protected $dbconn;

	public function __construct(){
		$dbcfg = App::$config->getItem('database');
		$db_filepath = $dbcfg['database_filepath'];
		$dsn = "sqlite:{$db_filepath}";

		//$this->dbconn = new PDO($dsn, null, null, array(PDO::ATTR_PERSISTENT => false));
		$this->dbconn =  new SQLite3($db_filepath);
		$this->dbconn->enableExceptions(true);
	}

	private function result2Array($res){
		$arr= array();
		$count = 0;
		while($row = $res->fetchArray()){
	        foreach($row as $i=>$value) {
	            $arr[$count][$i] = $value;
	        }
			$count++;
		}
		return $arr;
	}

	public function query($sql, $para=null, $returnAssociativeArray=true){

		//$sth = $this->dbconn->prepare($sql, array(PDO::ATTR_CURSOR => PDO::CURSOR_FWDONLY));
		$sth = $this->dbconn->prepare($sql);
		if(!$sth){
			throw new \Exception('Can not access database');
		}
		if($para!==null){
			foreach ($para as $k => $p){
				$sth->bindValue(($k+1), $p);
			}
		}
		$res = $sth->execute();

		$ds = array();
		if($returnAssociativeArray){
		    $ds = $this->result2Array($res);
		}else{
			$ds = $res->fetchArray(SQLITE3_NUM);
		}

		return $ds;
	}

	public function queryNoneResult($sql, $para=null){
		//$sth = $this->dbconn->prepare($sql, array(PDO::ATTR_CURSOR => PDO::CURSOR_FWDONLY));
		$sth = $this->dbconn->prepare($sql);
		if(!$sth){
			throw new \Exception('Can not access database');
		}
		if($para!==null){
			foreach ($para as $k => $p){
				$sth->bindValue(($k+1), $p);
			}
		}
		$success = $sth->execute();

		$rowCount = false;

		if($success){
			//$row = $success->fetchArray();
			$rowCount = $success->numColumns();
		}

		return $rowCount;
	}

	public function querySingleRow($sql, $para=null, $returnAssociativeArray=true){
		//$sth = $this->dbconn->prepare($sql, array(PDO::ATTR_CURSOR => PDO::CURSOR_FWDONLY));
		$sth = $this->dbconn->prepare($sql);
		if(!$sth){
			throw new \Exception('Can not access database');
		}

		
		if($para!==null){
			foreach ($para as $k => $p){
				$sth->bindValue(($k+1), $p);
			}
		}
		$res = $sth->execute();


		if($returnAssociativeArray){
			$row = $res->fetchArray(SQLITE3_ASSOC);
		}else{
			$row = $res->fetchArray(SQLITE3_NUM);
		}
		
		return $row;
	}

	public function queryDataIsExist($sql, $para=null){

		$row = $this->querySingleRow($sql, $para);

		return is_array($row);
	}
}
