<?php
namespace LMVC\System;
use LMVC\System\Foundation\Singleton;


class Request extends Singleton
{
    protected static $instance;
    protected $items = array();

    public static function getInstance(){
        if (null === static::$instance) {
            static::$instance = new static();
        }

        return static::$instance;
    }

    public static function post($name){
        if (isset($_SERVER['CONTENT_TYPE']) && strpos($_SERVER['CONTENT_TYPE'], 'application/json') !== FALSE) {
            $data = json_decode(file_get_contents('php://input'), true);
            return isset($data[$name]) ? $data[$name] : null;
        }
        return isset($_POST[$name]) ? $_POST[$name] : null;
    }

    public static function get($name){
        if(isset($_GET[$name])){
            return $_GET[$name];
        }

        return null;
    }

    public static function put($name){

        if($_SERVER['REQUEST_METHOD']!='PUT'){
            return null;
        }

        parse_str(file_get_contents('php://input'), $putArgs);
        if(isset($putArgs[$name])){
            return $putArgs[$name];
        }
        return null;
    }

    public static function delete($name){

        if($_SERVER['REQUEST_METHOD']!='DELETE'){
            return null;
        }

        parse_str(file_get_contents('php://input'), $putArgs);
        if(isset($putArgs[$name])){
            return $putArgs[$name];
        }
        return null;
    }

    public static function cookie($name){
        if(isset($_Cookie[$name])){
            return $_Cookie[$name];
        }

        return null;
    }

    public static function any($name){
        if(self::get($name)!==null){
            return self::get($name);
        }
        if(self::put($name)!==null){
            return self::put($name);
        }

        if(self::post($name)!==null){
            return self::post($name);
        }
        return self::delete($name);
    }
}
