<?php

namespace LMVC\System;

use LMVC\System\Foundation\Singleton;

class Router extends Singleton
{
	protected static $instance;
	protected $routes;

	public static function getInstance(){
        if (null === static::$instance) {
            static::$instance = new static();
        }
        
        return static::$instance;
    }

	public function __construct() {
		$this->routes = array('GET', 'POST', 'PUT', 'DELETE', 'CLI');
		$this->routes['GET'] = array();
		$this->routes['POST'] = array();
		$this->routes['PUT'] = array();
		$this->routes['DELETE'] = array();
		$this->routes['CLI'] = array();
	}
	public function addRoute($method, $uri, $classPath){
		if(is_array($method))
		{
			foreach($method as $one_method)
			{
				static::addRoute($one_method, $uri, $classPath);
			}
			return;
		}
		$classPath = '\\App\\Controllers\\'.$classPath;
		$this->routes[$method][$uri] = $classPath;

	}

	public function route($method, $uri){
		// print_r($this->routes);
		// exit;

		if(isset($this->routes[$method][$uri])){
			$classPath = $this->routes[$method][$uri];

			$segments =  explode('@', $classPath);

			// $controller = new $segments[0];
			// $controller->$segments[1]();
			return array($segments[0], $segments[1], NULL);

		}else{
			foreach($this->routes[$method] as $route => $classPath)
			{
				
				if(substr($route, strlen($route)-1)!==")"){
					$route = $route."$";
				}
				$route = str_replace("(:arg)", "{1}(.+)", $route);
				$route = str_replace("/", "\\/", $route);
				$route = "/^{$route}/";

				if(preg_match($route, $uri, $args)){
					
					$segments = explode('@', $classPath);


					if(sizeof($args)>1){
						array_shift($args);
					}else{
						$args = array();
					}


					// $controller = new $segments[0];
					// call_user_func_array(array($controller, $segments[1]), $args);
					return array($segments[0], $segments[1], $args);
				}
			}
			
			global $application;
			$application->error("$method $uri NOT FOUND", 404);
		}
	}
}