<?php
namespace LMVC\System;

use LMVC\System\App;

class Toolbox
{

	public static function baseUrl($relativeUrl){
		$baseUri = App::$config->getItem('base_uri');
		if(substr($baseUri, strlen($baseUri)-1,1)=='/')
		{
			$baseUri=ubstr($baseUri, 0, strlen($baseUri)-1);
		}

		if(substr($relativeUrl,0,1)!='/'){
			$relativeUrl = '/'.$relativeUrl;
		}

		return $baseUri.$relativeUrl;
	}
	

	public static function log($logLevel, $message){
		$cfgLogLevel = App::$config->getItem('log_level');
		$shouldLog = false;
		switch($cfgLogLevel){
			case 'debug':
				if($logLevel == 'debug' || $logLevel == 'error'){
					$shouldLog = true;
				}
				break;
			case 'error':
				if($logLevel == 'error'){
					$shouldLog = true;
				}
				break;
		}

		if($shouldLog){
			$date = date("Y-m-d");
			$time = date("H:i:s");
			$fileName = "log_{$date}.log";
			$logPath = App::$config->getItem('log_path');

			if(empty($logPath)){
				$logPath = __DIR__."../data/log";
			}

			$logPath.='/'.$fileName;
			$message = "{$date} {$time}\t{$logLevel}\t{$message}\n";
			exec("qsh helpdeskd.fixMod -v '{\"path\":\"".$logPath."\",\"type\":\"666\"}'");
			file_put_contents($logPath, $message, FILE_APPEND | LOCK_EX);
		}
		
	}
}