<?php

addRoute(array('GET'), '/', 'Main@index');

addRoute(array('GET'), '/api/v1/lang', 'Api\\Misc@getLang');
addRoute(array('GET'), '/api/v1/lang/(:arg)', 'Api\\Misc@getLang');
addRoute(array('GET'), '/api/v1/version', 'Api\\Misc@getVersion');
addRoute(array('GET'), '/api/v1/applog', 'Api\\Misc@getAppLog');
addRoute(array('GET'), '/api/v1/applog/(:arg)', 'Api\\Misc@getAppLog');
addRoute(array('POST'), '/api/v1/usergroup', 'Api\\Misc@postUserGroup');

addRoute(array('GET'), '/api/v1/remote_access', 'Api\\RemoteAccess@getStatus');
addRoute(array('GET'), '/api/v1/remote_access/getkeys', 'Api\\RemoteAccess@getKeys');
addRoute(array('POST'), '/api/v1/remote_access/enable', 'Api\\RemoteAccess@enable');
addRoute(array('POST'), '/api/v1/remote_access/disable', 'Api\\RemoteAccess@disable');
addRoute(array('POST'), '/api/v1/remote_access/extend', 'Api\\RemoteAccess@extend');
addRoute(array('POST'), '/api/v1/remote_access/confirm', 'Api\\RemoteAccess@confirm');
addRoute(array('POST'), '/api/v1/remote_access/clearRemoteLog', 'Api\\RemoteAccess@disableReportResultLog');
addRoute(array('GET'), '/api/v1/remote_access/ssh-status', 'Api\\RemoteAccess@sshStatus');

addRoute(array('GET'), '/api/v1/log', 'Api\\CustomPortalTicket@getSystemLog');
addRoute(array('GET'), '/api/v1/sysinfo', 'Api\\CustomPortalTicket@getSystemInfo');
addRoute(array('POST'), '/api/v1/log/download/(:arg)', 'Api\\CustomPortalTicket@downloadSystemLog');
addRoute(array('POST'), '/api/v1/attachment/upload', 'Api\\CustomPortalTicket@uploadAttachment');
addRoute(array('POST'), '/api/v1/attachment/remove', 'Api\\CustomPortalTicket@removeAttachment');

//Callhome
addRoute(array('POST'), '/api/v1/callhome/setting', 'Api\\CallHome@setCallHome');
addRoute(array('GET'), '/api/v1/callhome/setting', 'Api\\CallHome@getCallHome');

//CP
addRoute(array('POST'), '/api/v1/custom_portal/ticket', 'Api\\CustomPortalTicket@submitTicket');
addRoute(array('GET'), '/api/v1/custom_portal/issue-category/(:arg)', 'Api\\CustomPortalTicket@getIssueCategory');
//addRoute(array('GET'), '/api/v1/custom_portal/issue-type/(:arg)', 'Api\\CustomPortalTicket@getIssueType');
addRoute(array('GET'), '/api/v1/custom_portal/country/(:arg)', 'Api\\CustomPortalTicket@getCountry');
addRoute(array('GET'), '/api/v1/custom_portal/os/(:arg)', 'Api\\CustomPortalTicket@getOs');
addRoute(array('GET'), '/api/v1/custom_portal/customer/(:arg)', 'Api\\CustomPortalTicket@getCustomer');
addRoute(array('GET'), '/api/v1/custom_portal/firmware-version', 'Api\\CustomPortalTicket@getFirmwareVersion');
addRoute(array('GET'), '/api/v1/custom_portal/timezone', 'Api\\CustomPortalTicket@getTimezone');

addRoute(array('GET'), '/api/v1/diagnostictool', 'Api\\DiagnosticTool@getSettings');
addRoute(array('POST'), '/api/v1/diagnostictool', 'Api\\DiagnosticTool@setSettings');
addRoute(array('POST'), '/api/v1/diagnostictool/blk_tmp', 'Api\\DiagnosticTool@postBlk_tmp');
addRoute(array('GET'), '/api/v1/diagnostictool/blk_tmp', 'Api\\DiagnosticTool@getBlk_tmp');

addRoute(array('GET'), '/api/v1/diagnostictool/(:arg)', 'Api\\DiagnosticTool@getSettings');
addRoute(array('POST'), '/api/v1/diagnostictool/(:arg)', 'Api\\DiagnosticTool@setSettings');

addRoute(array('GET'), '/api/v1/settings', 'Api\\Settings@getSettings');
addRoute(array('POST'), '/api/v1/settings', 'Api\\Settings@setSettings');
addRoute(array('POST'), '/api/v1/settings/token', 'Api\\Settings@refreshToken');
addRoute(array('GET'), '/api/v1/settings/(:arg)', 'Api\\Settings@getSettings');
addRoute(array('POST'), '/api/v1/settings/(:arg)', 'Api\\Settings@setSettings');
//QID
addRoute(array('POST'), '/api/v1/settings/login', 'Api\\Settings@loginQID');
addRoute(array('POST'), '/api/v1/settings/bind', 'Api\\Settings@bindQID');
addRoute(array('POST'), '/api/v1/settings/logout', 'Api\\Settings@logoutQID');
addRoute(array('POST'), '/api/v1/settings/unbind', 'Api\\Settings@unbindQID');
addRoute(array('POST'), '/api/v1/settings/qidinfo', 'Api\\Settings@getQidInfo');
addRoute(array('POST'), '/api/v1/settings/qidbindinfo', 'Api\\Settings@bindQidInfo');

addRoute(array('CLI'), '/cli/callhome/woof', 'Cli\\CallHome@woof');
addRoute(array('CLI'), '/cli/callhome/regular', 'Cli\\CallHome@regular');
addRoute(array('CLI'), '/cli/callhome/regularTime', 'Cli\\CallHome@regularTime');
addRoute(array('CLI'), '/cli/callhome/enable', 'Cli\\CallHome@enable');
addRoute(array('CLI'), '/cli/callhome/disable', 'Cli\\CallHome@disable');
addRoute(array('CLI'), '/cli/callhome/liveOrDie', 'Cli\\CallHome@liveOrDie');


addRoute(array('CLI'), '/cli/watchdog/test/(:arg)-(:arg)', 'Cli\\WatchDog@test');
addRoute(array('CLI'), '/cli/watchdog/vaildSid/(:arg)', 'Cli\\WatchDog@isSidVaild');
addRoute(array('CLI'), '/cli/watchdog/woof', 'Cli\\WatchDog@woof');
addRoute(array('CLI'), '/cli/watchdog/liveOrDie', 'Cli\\WatchDog@liveOrDie');
addRoute(array('CLI'), '/cli/watchdog/uninstall', 'Cli\\WatchDog@uninstall');

addRoute(array('CLI'), '/cli/supportutils/upload/(:arg)', 'Cli\\SupportUtils@upload');
addRoute(array('CLI'), '/cli/supportutils/applog/reg/(:arg)::(:arg)', 'Cli\\SupportUtils@registerExternalLog');
addRoute(array('CLI'), '/cli/supportutils/applog/unreg/(:arg)', 'Cli\\SupportUtils@unRegisterExternalLog');
addRoute(array('CLI'), '/cli/supportutils/applog/list', 'Cli\\SupportUtils@listRegisteredExternalLog');

addRoute(array('CLI'), '/cli/db/migrate', 'Cli\\DbUtils@migrate');
