<?php

function lang($key)
{
    return \LMVC\System\App::$lang->item($key);
}

function config($key, $value = null)
{
    if ($value === null) {
        return \LMVC\System\App::$config->getItem($key);
    } else {
        \LMVC\System\App::$config->setItem($key, $value);
    }
}

function addRoute($method, $uri, $classPath)
{
    \LMVC\System\App::$router->addRoute($method, $uri, $classPath);
}

// 1: only number, 2: number + alphabet
function strRandom($type = 1, $length = 10)
{
    $charSet = '';

    switch ($type) {
    case '1':
        $charSet = '0123456789';
        break;
    case '2':
        $charSet = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        break;
    }

    $charLen = strlen($charSet);
    $rStr = '';

    for ($i = 0; $i < $length; ++$i) {
        $rStr .= $charSet[rand(0, $charLen - 1)];
    }

    return $rStr;
}

function curlWrapper($method = 'POST', $url = null, $data = null, $rawdata = false, $header = null)
{
    $caCert = config('app_dir').'/data/cacert.pem';

    $isPost = 0;
    if ($method == 'POST') {
        $isPost = 1;
    }

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    
    if($method == 'PUT'){
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "PUT");
    }else{
        curl_setopt($curl, CURLOPT_POST, $isPost);
    }

    if ($data != null) {
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
    }
    if ($header != null) {
        curl_setopt($curl, CURLOPT_HTTPHEADER, $header); 
    }
    else if ($rawdata) {
        curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: text/plain'));
    }

    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    // curl_setopt ($curl, CURLOPT_CAINFO, $caCert);
    if(!config('isTest')){
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, $caCert);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, $caCert);
    }else{
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
    }
    
    curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 8); 
    curl_setopt($curl, CURLOPT_TIMEOUT, 180);

    $isProxyEnable = shell_exec("/sbin/getcfg 'System' 'proxy toggle' -d 0");
    $isProxyEnable = str_replace("\n", '', $isProxyEnable);
    $proxyServer = shell_exec("/sbin/getcfg 'System' 'proxy server'");
    $proxyServer = str_replace("\n", '', $proxyServer);

    if ($isProxyEnable == 1 && !empty($proxyServer) && parse_url($url, PHP_URL_HOST) != 'localhost') {
        $proxyAddr = parse_url($proxyServer, PHP_URL_HOST) . ':' . parse_url($proxyServer, PHP_URL_PORT);
        curl_setopt($curl, CURLOPT_PROXY, $proxyAddr);

        $isProxyAuthEnable = shell_exec("/sbin/getcfg 'System' 'proxy authToggle' -d 0");
        $isProxyAuthEnable = str_replace("\n", '', $isProxyAuthEnable);

        if ($isProxyAuthEnable == 1) {
            $proxyUser = shell_exec("/sbin/getcfg 'System' 'proxy username'");
            $proxyUser = str_replace("\n", '', $proxyUser);
            $proxyPasswd = shell_exec("/sbin/getcfg 'System' 'proxy password'");
            $proxyPasswd = str_replace("\n", '', $proxyPasswd);

            if (!empty($proxyUser) && !empty($proxyPasswd)) {
                $proxyUserPwd = $proxyUser . ':' . $proxyPasswd;
                curl_setopt($curl, CURLOPT_PROXYUSERPWD, "$proxyUserPwd");
            }
        }
    }

    $srvOutput = curl_exec($curl);
    $httpStatusCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
    $curlErrMsg = curl_error($curl);
    $curlErrCode = curl_errno($curl);
    curl_close($curl);

    if ($curlErrCode) {
        $result = array('errCode' => $curlErrCode, 'errMsg' => $curlErrMsg);

        return array('status' => 'FALSE', 'httpStatusCode' => $httpStatusCode, 'result' => $result);
    }

    if ($httpStatusCode !== 200 || $srvOutput == false) {
        $srvOutput = json_decode($srvOutput);

        return array('status' => 'FALSE', 'httpStatusCode' => $httpStatusCode, 'result' => $srvOutput);
    }

    return $srvOutput;
}

function httpsOrNot()
{
    $isHttpForce = trim(shell_exec('qgetcfg --app=SYS_CONF system-web-server "Force SSL" -d 0'));
    if($isHttpForce=="1")return 'https';
    
    if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') {
        return 'https';
    } else {
        return 'http';
    }
}
function isHttps()
{
    return httpsOrNot()=="https";
}

function getCgiPort(){
    $serverPort= 
        isHttps() ? 
        trim(shell_exec("/usr/bin/qgetcfg --app=SYS_CONF 'system-web-server' 'HTTPS Port' -d 443")) : 
        trim(shell_exec("/usr/bin/qgetcfg --app=SYS_CONF 'system-web-server' 'Web Access Port' -d 80"));
    return $serverPort;
}

function apiFormater($res = null, $status = 0)
{
    if (!is_array($res)) {
        $result['result'] = $res;
    } elseif (!empty($res)) {
        $result = $res;
    }
    $result['status'] = $status;
    $result['message'] = apiReturnMsg($status);

    return $result;
}

function apiReturnMsg($status)
{
    $msg = array();

    $msg['0'] = '';
    $msg['2000'] = 'Permission denied';
    $msg['2001'] = 'Can not connect to the server';
    $msg['2002'] = 'Invalid ticket ID';
    $msg['2003'] = 'Invalid Email';
    $msg['2004'] = 'Server is too busy';
    $msg['2005'] = 'Can not establish secure tunnel';
    $msg['2006'] = 'Can not connect to the ticketing system';
    $msg['2007'] = 'Remote access case is already enabled';
    $msg['2008'] = 'Remote access case is already disabled';
    $msg['2009'] = 'Remote access case is already closed';
    $msg['2010'] = 'Remote access case is not activate';
    $msg['2011'] = 'Can not remove QTS support account';
    $msg['2012'] = 'Can not create QTS support account';
    $msg['2013'] = 'Can not extend ticket expire time';
    $msg['2014'] = 'Request timeout';
    $msg['2015'] = 'File is too large';
    $msg['2016'] = 'Disallow file type';
    $msg['2017'] = 'File upload failed';
    $msg['2018'] = 'Remote access case is already expired';
    $msg['2019'] = 'Can\'t get ssh state';
    $msg['2020'] = 'Permission denied';
    $msg['2021'] = 'ssh: Connection timed out';
    $msg['2022'] = 'No ssh config /mnt/HDA_ROOT/.config/ssh/';


    //qid
    $msg['3000'] = 'No Access Token in DB';
    $msg['3001'] = 'QID login failed';
    $msg['3002'] = 'AccountCenter user info failed';
    $msg['3003'] = 'Can not create ticket';
    $msg['3004'] = 'QID Token expired';
    $msg['3005'] = 'QID not match user.';
    $msg['3006'] = 'Call Home Time Error';

    if (isset($msg[$status])) {
        return $msg[$status];
    } else {
        return 'Unknown Error';
    }
}

function sizeConvert($size)
{
    $unit = ' KMGTP';
    $factor = floor((strlen($size) - 1) / 3);
    $convertedSize = sprintf('%.2f', $size / pow(1024, $factor)).@$unit[$factor].'B';

    return $convertedSize;
}

function colorize($msg, $status)
{
    $colorPrefix = '';

    switch ($status) {
    case 'SUCCESS':
        $colorPrefix = '[32m';
        break;
    case 'ERROR':
        $colorPrefix = '[31m';
        break;
    case 'WARN':
        $colorPrefix = '[33m';
        break;
    case 'NOTICE':
        $colorPrefix = '[34m';
        break;
    default:
        throw new Exception('Invalid Status: '.$status);
        break;
    }

    return chr(27).$colorPrefix.$msg.chr(27).'[0m';
}
