<?php
$lang['dialog-wizard-step'] = "Step";
$lang['dialog-wizard-quickStart-title'] = "Quick Start";
$lang['dialog-wizard-quickStart-title-1'] = "Welcome to Helpdesk";
$lang['dialog-wizard-quickStart-content-1'] = "You can submit technical support requests directly or suggest new features to our support team via Helpdesk. If you need to solve a technical issue, you can enable remote support so that our support team can directly access your device and fix any technical issues. Consult the user guides, FAQs, and application notes before requesting assistance.";
$lang['dialog-wizard-quickStart-title-2'] = "Submit a Help Request";
$lang['dialog-wizard-quickStart-content-2'] = "You must be logged in as an administrator before submitting a help request. On the \"Help Request\" page, enter your details and Helpdesk will automatically retrieve information regarding the device hardware and logs. Our support team will contact you via the email address you provided.";
$lang['dialog-wizard-quickStart-content-3'] = "If your issue cannot be resolved normally, our support team will request remote access to your system. To do so, go to \"Remote Support\", enter your ticket ID and send the private key to our support team. You can check the progress afterwards and will receive a report once the session is finished.";
$lang['dialog-wizard-quickStart-title-4'] = "How to Encrypt a Shared Folder";
$lang['dialog-wizard-quickStart-content-4'] = "You can backup, move, or encrypt your data before allowing our support team to connect to your device. To encrypt a shared folder, go to Control Panel > Privilege Settings > Shared Folder > Edit Properties.";
$lang['dialog-window-about-title'] = "About";
$lang['dialog-window-about-version'] = "Version";
$lang['dialog-window-remoteAgree-agreeTermOfService'] = "I agree to these Terms of Service.";
$lang['dialog-window-remoteAgree-title'] = "QNAP Helpdesk Terms of Service";
$lang['dialog-window-remoteAgree-description'] = "Please carefully read the QNAP Helpdesk Terms of Service before enabling remote support. These Terms of Service are also available in the \"Remote Support\" page.";
$lang['dialog-window-enableRemote-description'] = "A private key and temporary account have been created to verify and enable remote support.";
$lang['dialog-window-enableRemote-content-1'] = "Select \"Confirm\" to send these temporary account details to the Helpdesk server. *This transmission and the remote support process uses SSL to protect the data transfer.";
$lang['dialog-window-enableRemote-content-2'] = "The entire remote support transmission process uses 256-bit SSL connectivity for data security and connects to service.qnap.com ports 22, 443.";
$lang['dialog-window-productInfo-title'] = "Product Information";
$lang['dialog-window-productInfo-pmn'] = "Product Model Name";
$lang['dialog-window-productInfo-fv'] = "Firmware Version";
$lang['dialog-window-productInfo-psn'] = "Product Serial Number";
$lang['dialog-window-productInfo-hdmac'] = "Hard drive model and capacity";
$lang['dialog-window-productInfo-rc'] = "RAID configuration";
$lang['dialog-window-productInfo-sl'] = "System log";
$lang['dialog-window-productInfo-detectFail'] = "Detect fail";
$lang['dialog-window-productInfo-content'] = "If the results differ from your setup or are shown as \"Detect Fail\", include this in your message. The model name and serial number can be found on the device.";
$lang['dialog-popup-signin-title'] = "Sign in";
$lang['dialog-popup-signin-text'] = "Please log in with your myQNAPcloud account to submit a ticket.";
$lang['dialog-popup-leaveWarning-title'] = "Are you sure you want to leave this page?";
$lang['dialog-popup-leaveWarning-text'] = "All of the unsaved information, configurations, and attached files will be discarded.";
$lang['dialog-popup-remoteAlreadyDoSomethingWarning-text-enabled'] = "Your ticket is already enabled remote support, please go back and check again. If the status of the Remote Support page is not changed accordingly, please contact our support directly for help.";
$lang['dialog-popup-remoteAlreadyDoSomethingWarning-text-disabled'] = "Your ticket is already disabled remote support, please go back and check again. If the status of the Remote Support page is not changed accordingly, please contact our support directly for help.";
$lang['dialog-popup-remoteDisableWarning-title'] = "Do you want to disable remote support?";
$lang['dialog-popup-remoteDisableWarning-text'] = "Helpdesk will terminate your remote support request, regardless of whether it is completed or not.";
$lang['dialog-window-remoteAgree-termOfConditions-1'] = "QNAP Helpdesk Term of Service";
$lang['dialog-window-remoteAgree-termOfConditions-2'] = "QNAP Systems, Inc. (\"QNAP\") provides remote support through the QNAP Helpdesk. By enabling remote support through QNAP Helpdesk, you, individually or as an authorized officer or employee of your company, agree to the QNAP Helpdesk terms of service set forth below. Review the terms of service before clicking \"Enable Remote Support\" on QNAP Helpdesk or TeamViewer.";
$lang['dialog-window-remoteAgree-termOfConditions-3'] = "";
$lang['dialog-window-remoteAgree-termOfConditions-4'] = "The QNAP technical support team provides services in accordance with the following terms and conditions:";
$lang['dialog-window-remoteAgree-termOfConditions-5'] = "1.By clicking \"Enable Remote Support\" on QNAP Helpdesk or TeamViewer, you have requested the assistance of the QNAP technical support team through a remote connection to your QNAP Network Attached Storage (\"NAS\").  The ability for QNAP technical support team to remotely access your computer significantly enhances the quick resolution of your technical issue. By requesting the assistance of QNAP technical support, you understand and authorize QNAP to have partial or full unrestricted access to your NAS as well as its contents. The remote support session period begins on the day QNAP Helpdesk generates the Remote Support Private Key (\"key\") and ends on the day the key expires.";
$lang['dialog-window-remoteAgree-termOfConditions-6'] = "2.Clicking \"Enable Remote Support\" does not guarantee that the QNAP technical support team or any QNAP employee will conduct remote support during the remote support session period. You hereby acknowledge and agree that QNAP may verify your remote support request through online verification procedures and require the extension of the key’s validity with your authorization.";
$lang['dialog-window-remoteAgree-termOfConditions-7'] = "3.Although QNAP cannot guarantee that the provision of QNAP remote support will resolve your issue, QNAP will make reasonable efforts to perform support services in a professional manner, to the extent permitted by law.";
$lang['dialog-window-remoteAgree-termOfConditions-8'] = "4.Before enabling remote support, you acknowledge that you have taken the necessary precautions to secure your data. These precautions include moving, backing up, deleting or encrypting any confidential or personal files on your NAS before starting the remote support session.  QNAP does not provide data backup or restoration services during the remote support session. QNAP does not guarantee virus-free operations and will not commit to running virus scans during the remote support session. You are solely responsible for maintaining and backing up all information, files, or any other data and software stored on your device before enabling remote support.  By starting the remote support session, you acknowledge and agree that QNAP has no responsibility or liability under any circumstance at any time for any loss, corruption, or exposure of data during the session.";
$lang['dialog-window-remoteAgree-termOfConditions-9'] = "5.QNAP may download or use software, inspect system data, take remote control of the NAS, and modify its settings with or without additional authorization from you after the remote support session is started. QNAP may also retrieve data including but not limited to system logs, statistical usage information, and system profile information such as hard drive information or running processes during the remote session to solve your issue and continue to use that data to improve product quality after the support session is closed.";
$lang['dialog-window-remoteAgree-termOfConditions-10'] = "6.By starting the remote support session, you acknowledge and agree that QNAP will record the remote support session through photo or video format. The copyright and ownership of such recording belong to QNAP. The recording may be provided to anonymous, affiliated third-parties with or without additional authorization from you. QNAP has no responsibility or liability under any circumstance at any time for the loss, corruption, or exposure of your data caused by recording the session and its subsequent sharing.";
$lang['dialog-window-remoteAgree-termOfConditions-11'] = "7.If you are in any way unsure about the identity, technical ability, or trustworthiness of QNAP and do not wish QNAP to have access to your NAS or its data, do not click \"Enable Remote Support\".";
$lang['dialog-window-remoteAgree-termOfConditions-12'] = "8.Except for sections 1-7, in no circumstance shall QNAP, its affiliates, or any of their respective officers, shareholders, employees, contractors, or licensors (\"QNAP parties\") be liable for any direct, indirect, punitive, special, exemplary, incidental, consequential, or other damages of any kind (including but not limited to hardware and system damage, loss of data, loss of profits, loss of any other economic advantage) arising out of, or in any way connected to the remote support services provided by the QNAP technical support team, any interruption to the use of the remote control service, or any content obtained from or through the remote support service, even if the QNAP parties from which damages are sought have been previously advised of the possibility of such damages.";
$lang['dialog-window-remoteAgree-termOfConditions-13'] = "9.Some QNAP products include third-party software. Third-party software may be subject to their own terms of service. If you need technical support related to these third-party software, contact the third party in accordance with their terms of service.";
$lang['dialog-window-remoteAgree-termOfConditions-14'] = "10.The foregoing terms shall not apply to claims made against QNAP in connection with an existing technical support agreement.";
$lang['dialog-window-remoteAgree-termOfConditions-15'] = "11.Except otherwise specified, QNAP specifically disclaims any and all statutory or implied warranties, related to or arising in any way out of these terms, including any implied warranty or merchantability or fitness for a particular purpose. Except as provided above, in no event shall QNAP have any liability for any direct, indirect, special, incidental, or consequential damages, including but not limited to damages for loss of profit, loss of data, loss of use or equipment or facilities, or interruption of business, arising in any way out of these terms and conditions, under any theory of liability, whether or not QNAP has been advised of the possibility of such damage.";
$lang['dialog-window-remoteAgree-termOfConditions-16'] = "12.QNAP reserves the right, at its sole discretion, to modify or replace these terms of service at any time. If the revision is material, QNAP will provide at least thirty (30) days' notice prior to any new terms taking effect. What constitutes a material change will be determined at QNAP’s sole discretion. Any dispute, claim, or controversy in connection with or arising under the use of QNAP Helpdesk or this terms of service, its construction, existence, interpretation, validity, or any breach hereof which cannot be amicably settled between the QNAP parties and other individuals, groups, organizations or companies (\"parties\"), shall be governed by the laws of R.O.C. and shall be subject to the jurisdiction of the District Court of Taipei, Taiwan, R.O.C.";
$lang['dialog-window-remoteAgree-termOfConditions-17'] = "";
$lang['dialog-popup-uploadFilePreventionAlert-text'] = "You can only upload 8 files. The remaining files will not be uploaded.";
$lang['dialog-popup-uploadFileIgnorelAlert-text'] = "You can only upload 8 files. You must remove some attached files before you can add others.";
$lang['dialog-popup-agreeAttachLog-title']="You have not selected \"I am allowing QNAP Support to access my system logs\". Would you like to select that option now?";
$lang['dialog-popup-agreeAttachLog-descripiton'] = "System logs help QNAP Support assess issues on your device and provide you with timely solutions. These logs include errors, warnings, and other important device system events that occurred over a certain time period.";

//Diagnostic Waring #SPEC:17604
$lang['dialog-popup-doNotAsk'] = "Do not show this message again";
$lang['dialog-popup-diagnosticwarn-descripiton']="These diagnostic tools allow you to quickly analyze kernel records and other system information. These reports are provided for reference only. Serious system issues should only be resolved by qualified technical personnel. For more information, refer to relevant technical documentation or contact the device manufacturer.";
$lang['dialog-popup-diagnosticwarn-highlight']="The content of these reports cannot be used as proof for refund or replacement without first consulting a qualified technical personnel.";
$lang['dialog-popup-diag-HDDStressWarn-descripiton']="The time taken for the HDD stress test to complete will vary based on your system configuration. It may take up to a few hours to complete. Please note that no other tests will be run during HDD stress testing.";

//Update Warning #SPEC:19461
$lang['dialog-popup-askMeLater'] = "Ask me again later";
$lang['dialog-popup-update-text']="To access new features and improve service quality, please update Helpdesk to the latest version.";
$lang['dialog-popup-update-highlight']="View release notes";
$lang['dialog-popup-update-cancel']="Update Later";
$lang['dialog-popup-update-confirm']="Update Now";

//QID #SPEC:19372
$lang['dialog-popup-agreeAttachLog-notice'] = "You can download logs in \${diagnosticTool} > \${dumpLog}.";

//Jira #QNEHLD00-40
$lang['dialog-agreeSshEnable-title'] = "Enable SSH";
$lang['dialog-agreeSshEnable-content'] = "SSH is automatically enabled during remote support and disabled when remote support ends.";
